---
title: Physics
slug: Games/Tutorials/2D_breakout_game_Phaser/Physics
tags:
  - 2D
  - Beginner
  - Canvas
  - Games
  - JavaScript
  - Phaser
  - Tutorial
  - physics
---
<div>{{GamesSidebar}}</div>

<p>{{PreviousNext("Games/Workflows/2D_Breakout_game_Phaser/Move_the_ball", "Games/Workflows/2D_Breakout_game_Phaser/Bounce_off_the_walls")}}</p>

<div class="summary">
<p>This is the <strong>5th step</strong> out of 16 of the <a href="/en-US/docs/Games/Workflows/2D_Breakout_game_Phaser">Gamedev Phaser tutorial</a>. You can find the source code as it should look after completing this lesson at <a href="https://github.com/end3r/Gamedev-Phaser-Content-Kit/blob/gh-pages/demos/lesson05.html">Gamedev-Phaser-Content-Kit/demos/lesson05.html</a>.</p>
</div>

<p><span class="seoSummary">For proper collision detection between objects in our game we will need to have physics; this article introduces you to what's available in Phaser, as well as demonstrating a typical simple setup.</span></p>

<h2 id="Adding_physics">Adding physics</h2>

<p>Phaser is bundled with three different physics engines — Arcade Physics, P2 and Ninja Physics — with a fourth option, Box2D, being available as a commercial plugin. For simple games like ours, we can use the Arcade Physics engine. We don't need any heavy geometry calculations — after all it's just a ball bouncing off walls and bricks.</p>

<p>First, let's initialize the Arcade Physics engine in our game. Add the <code>physics.startSystem()</code> method at the beginning of the <code>create</code> function (make it the first line inside the function), as shown below:</p>

<pre class="brush: js notranslate">game.physics.startSystem(Phaser.Physics.ARCADE);
</pre>

<p>Next, we need to enable our ball for the physics system — Phaser object physics is not enabled by default. Add the following line at the bottom of the <code>create()</code> function:</p>

<pre class="brush: js notranslate">game.physics.enable(ball, Phaser.Physics.ARCADE);
</pre>

<p>Next, if we want to move our ball on the screen, we can set <code>velocity</code> on its <code>body</code>. Add the following line, again at the bottom of <code>create()</code>:</p>

<pre class="brush: js notranslate">ball.body.velocity.set(150, 150);
</pre>

<h2 id="Removing_our_previous_update_instructions">Removing our previous update instructions</h2>

<p>Remember to remove our old method of adding values to <code>x</code> and <code>y</code> from the <code>update()</code> function:</p>

<pre class="brush: js notranslate">function update() {
<s>    ball.x += 1;</s>
<s>    ball.y += 1;</s>
}
</pre>

<p>we are now handling this properly, with a physics engine.</p>

<h2 id="Final_code_check">Final code check</h2>

<p>The latest code should look like this:</p>

<pre class="brush: js notranslate">var ball;

function preload() {
    game.scale.scaleMode = Phaser.ScaleManager.SHOW_ALL;
    game.scale.pageAlignHorizontally = true;
    game.scale.pageAlignVertically = true;
    game.stage.backgroundColor = '#eee';
    game.load.image('ball', 'img/ball.png');
}

function create() {
    game.physics.startSystem(Phaser.Physics.ARCADE);
    ball = game.add.sprite(50, 50, 'ball');
    game.physics.enable(ball, Phaser.Physics.ARCADE);
    ball.body.velocity.set(150, 150);
}

function update() {
}
</pre>

<p>Try reloading <code>index.html</code> again — The ball should now be moving constantly in the given direction. At the moment, the physics engine has gravity and friction set to zero. Adding gravity would result in the ball falling down while friction would eventually stop the ball.</p>

<h2 id="Fun_with_physics">Fun with physics</h2>

<p>You can do much more with physics, for example by adding <code>ball.body.gravity.y = 100;</code> you will set the vertical gravity of the ball. As a result it will be launched upwards, but then fall due to the effects of gravity pulling it down.</p>

<p>This kind of functionality is just the tip of the iceberg — there are various functions and variables that can help you manipulate the physics objects. Check out the official <a href="http://phaser.io/docs#physics">physics documentation</a> and see the huge collection of examples using the <a href="http://phaser.io/examples/v2/category/arcade-physics">Arcade</a> and <a href="http://phaser.io/examples/v2/category/p2-physics">P2</a> physics systems.</p>

<h2 id="Compare_your_code">Compare your code</h2>

<p>You can check the finished code for this lesson in the live demo below, and play with it to understand better how it works:</p>

<p>{{JSFiddleEmbed("https://jsfiddle.net/end3r/bjto9nj8/","","400")}}</p>

<h2 id="Next_steps">Next steps</h2>

<p>Now we can move to the next lesson and see how to make the ball <a href="/en-US/docs/Games/Workflows/2D_Breakout_game_Phaser/Bounce_off_the_walls">bounce off the walls</a>.</p>

<p>{{PreviousNext("Games/Workflows/2D_Breakout_game_Phaser/Move_the_ball", "Games/Workflows/2D_Breakout_game_Phaser/Bounce_off_the_walls")}}</p>
